;****** Deplacement avec souris en SCREEN 5 ******

;-------------------------------------------------
;*** Directives d'assemblage spcifique AsMSX ***
.bios
.page 2
.rom
.start DEBUT

;---------------------------------------
;*** Adresses des tables du SCREEN 5 ***
NAMTBL equ 0000h
SPRTBL equ 7800h
SPRATR equ 7600h

;--------------------------
;*** Dbut du programme ***
DEBUT:
call DISSCR	; on coupe l'affichage
ld hl,0f3e9h	; on rcupre l'adresse de la couleur d'criture dans hl (zone de communication)
ld [hl],15	; couleur d'criture en blanc
inc hl		; on rcupre l'adresse de la couleur de fond
ld [hl],0	; couleur de fond transparente
inc hl		; on rcupre l'adresse de la couleur de bordure
ld [hl],0	; couleur de bordure transparente

;---------------------------
;*** Passage en SCREEN 5 ***
ld a,5		; on met le numro de SCREEN choisi dans l'accumulateur
call CHGMOD	; appel de la routine BIOS CHGMOD

;-----------
;*** CLS ***
ld hl,NAMTBL	; on met l'adresse de la table des noms dans hl
ld bc,27136	; on met la longueur en octets de la table des noms (ici 27136) dans 
		; le registre double bc
xor a		; on annule la valeur de l'accumulateur
call FILVRM	; appel de la routine FILVRM (on remplit la VRAM  partir de l'adresse contenue par hl,
		; sur une longueur d'octets contenue par bc, avec la valeur contenue par l'accumulateur
		; ici 0, on remplit donc toute la table des noms par rien : on efface l'cran !

;----------------------------
;*** Dfinition du sprite ***
ld hl,SPR_CUR	; on met dans hl l'adresse des donnes qui constituent notre sprite
ld de,SPRTBL	; on met dans de l'adresse de destination
ld bc,8		; on met dans bc la longueur en octets des donnes  transfrer
call LDIRVM	; on appelle la routine BIOS LDIRVM, qui va copier les donnes indiques dans la VRAM

;---------------------------------------------------
;*** Dfinition des attributs de sprite initiaux ***
ld hl,ATR_INITIAL	; on met hl  l'adresse de dpart des attributs initiaux du sprite
ld de,SPRITES		; le registre de est mis  l'adresse de la zone variable
ld bc,4			; le registre bc contient le nombre d'octets  transfrer
ldir			; on copie bc (ici 4) octets depuis hl (ATR_INITIAL) vers de (SPRITES)

;---------------------------------
;*** Activation de l'affichage ***
call ENASCR	; on active l'affichage

;-------------------------
;*** Boucle principale ***
LOOP:		; Label de la boucle principale
ld a,12		; on charge 12 dans l'accumulateur : c'est la valeur qui permet d'initialiser la souris
		; dans le port joystick n1
ld ix,01adh	; on fait appelle  une routine (NEWPAD) de la Sub-ROM MSX2, on charge donc l'adresse
		; de cette routine dans ix
call 015fh	; appel de la Sub-Rom MSX2 (en 015fh)

ld a,13		; on charge 13 dans l'accumulateur : c'est la valeur qui va permettre de grer le
		; dplacement horizontal de la souris
ld ix,01adh	; voir au-dessus
call 015fh	; idem

ld b,a		; on charge dans b la valeur renvoye par la routine (valeur du dplacement horizontal)
ld a,[SPRITES+1]; on charge dans l'accu l'abscisse variable du curseur
push af         ;sauvegarde de a
and 240         ;on met a  240 si suprieur
cp a,240        ;on compare si a=240
jr nz,suiteh    ;sinon mvt normal
bit 7,b         ;on vrifie si le mouvement de la souris est ngatif
                ;bit7 de b  1 implique que b>=128 donc z=1 indique que b est ngatif
jr z,finh       ;abandon si positif

suiteh:
pop af          ;rcupration de a
add a,b		; on additionne l'abscisse et le dplacement horizontal
ld[SPRITES+1],a	; on remet dans l'adresse de la variable le rsultat

finh:
ld a,14		; toute cette partie est la mme que la prcdente
ld ix,01adh	;  ceci prs que c'est la composante verticale qui
call 015fh	; est traite
ld b,a		; cette fois !
ld a,[SPRITES]
add a,b
ld[SPRITES],a

call DUMP	; appel  la sous-routine DUMP (qui permet de transfrer les valeurs en RAM vers la VRAM)
jp LOOP		; on boucle le programme

;------------------------------------------------
;*** Sous programme de transfert vers la VRAM ***
DUMP:		; label du sous-programme
halt		; synchronisation verticale
ld hl,SPRITES	; adresse de dpart
ld de,SPRATR	; adresse d'arrive
ld bc,4		; longueur du bloc  transfrer (en octets)
call LDIRVM	; appel  la routine BIOS LDIRVM
ret

;------------------
;*** Constantes ***
ATR_INITIAL:
	db 92,124,0,15

SPR_CUR:
    db  010h,010h,010h,0eeh,010h,010h,010h,000h

;-----------------
;*** Variables ***
.page 3

SPRITES:
ds 4